&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*------------------------------------------------------------------------

  File:             dRas.w

  Description:      sample RAS PROGRAM

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author:           Marcel FONDACCI
                    m.fondacci@4gl.fr

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/*  PROGRESS version from M.FONDACCI (4GL)                  www.4gl.fr
                          m.fondacci@4gl.fr
*/    
&SCOP    DNLEN  15                      /* Maximum domain name length       */
&SCOP    UNLEN  256                     /* Maximum user name length         */
&SCOP    PWLEN  256                     /* Maximum password length          */
&SCOP    NETBIOS_NAME_LEN  16           /* NetBIOS net name (bytes)         */

&SCOP    RAS_MaxDeviceType   16
&SCOP    RAS_MaxPhoneNumber  128
&SCOP    RAS_MaxIpAddress    15
&SCOP    RAS_MaxIpxAddress   21


&IF DEFINED(WINVER31) > 0 &then
            /*      Version 3.x sizes   */
            &SCOP    RAS_MaxEntryName       20
            &SCOP    RAS_MaxDeviceName      32
            &SCOP    RAS_MaxCallbackNumber  48
&ELSE
            /*      Other Versions      */
            &SCOP    RAS_MaxEntryName       256 
            &SCOP    RAS_MaxDeviceName      128
            &SCOP    RAS_MaxCallbackNumber  {&RAS_MaxPhoneNumber}
&ENDIF

&SCOP    RAS_MaxAreaCode        10
&SCOP    RAS_MaxPadType         32
&SCOP    RAS_MaxX25Address      200
&SCOP    RAS_MaxFacilities      200
&SCOP    RAS_MaxUserData        200


/*          ORIGINAL C DECLARATIONS
            -----------------------
                            typedef struct _RASDIALPARAMS {  
                               DWORD  dwSize; 
                               TCHAR  szEntryName[RAS_MaxEntryName + 1]; 
                               TCHAR  szPhoneNumber[RAS_MaxPhoneNumber + 1]; 
                               TCHAR  szCallbackNumber[RAS_MaxCallbackNumber + 1]; 
                               TCHAR  szUserName[UNLEN + 1]; 
                               TCHAR  szPassword[PWLEN + 1]; 
                               TCHAR  szDomain[DNLEN + 1] ; 
                            #if (WINVER >= 0x401)
                               DWORD  dwSubEntry;
                               DWORD  dwCallbackId;
                            #endif
                            } RASDIALPARAMS;
                            
                            
                            typedef struct _RASCONN {  
                                DWORD     dwSize; 
                                HRASCONN  hrasconn; 
                                TCHAR     szEntryName[RAS_MaxEntryName + 1]; 
                             
                            #if (WINVER >= 0x400) 
                                CHAR      szDeviceType[ RAS_MaxDeviceType + 1 ]; 
                                CHAR      szDeviceName[ RAS_MaxDeviceName + 1 ]; 
                            #endif 
                             
                            } RASCONN ; 
                            
                            typedef struct _RASENTRYNAME {  
                                DWORD  dwSize; 
                                TCHAR  szEntryName[RAS_MaxEntryName + 1]; 
                            }RASENTRYNAME; 
                            
                            typedef struct tagRASDEVINFO {
                                DWORD    dwSize;
                                TCHAR    szDeviceType[ RAS_MaxDeviceType + 1 ];
                                TCHAR    szDeviceName[ RAS_MaxDeviceName + 1 ];
                            } RASDEVINFOW;
                            

*/   


/* RAS ACTIVE structure
   ==================*/
   
                        &SCOP   lRASbase      4         /* dWSize */                    ~
                                            + 4         /* Handle to RAS connection */  ~
                                            + {&RAS_MaxEntryName}    + 1                   
                                            
                        &IF DEFINED(WINVER31) = 0 &then
                            &SCOP lRASConn  ( {&lRASBase} + {&RAS_MaxDeviceName} + 1    + {&RAS_MaxDeviceType} + 1     ~
                                              + 1 /* Alignment */ )
                        &else
                            &SCOP lRASConn  ( {&lRASBase} )
                        &endif
                                
                        /*&IF DEFINED(WINVER41) > 0 &then               ADAPT IF YOU ARE IN THIS CASE !
                         *     &SCOP   lRASConn {&lRASCONN}                                ~
                         *                      + (sizeof MAX-PATH)                        ~
                         *                      + 4            /* Sub-Entry */
                         *     &ENDIF*/
                      

/* RAS DIAL structure
   ================*/
                                                                                  
                        &UNDEFINE lRASBase   
                        &SCOP   lRASBase    4           /* dwSize */        ~
                                            + {&RAS_MaxEntryName}    + 1    ~
                                            + {&RAS_MaxPhoneNumber}  + 1    ~
                                            + {&RAS_MaxCallBackNumber}  + 1 ~
                                            + {&UNLEN}  + 1    ~
                                            + {&PWLEN}  + 1    ~
                                            + {&DNLEN}  + 1
                                            
                        &IF DEFINED(WINVER41) = 0 &then
                            &SCOP   lRASDIAL ( {&lRASBase} + 3         /* Alignment */ )
                        &ELSE
                            &SCOP   lRASDIAL ( {&lRASBase} + 4 + 4 + 3 /* Alignment */)
                        &ENDIF
                     
/* RAS ENTRY structure
   =================*/
                                                                                     
                        &SCOP   lRasEntryName   ( 4           /* dwSize */        ~
                                            + {&RAS_MaxEntryName}    + 1          ~
                                            + 3     /* Alignment */     )
                                            
        
/*       If you want to control the structures lengths...
                                      
                        Message "Length of RAS structures" skip
                                {&lrasConn} {&lRASDIAL} {&lRasEntryName}
                                                            view-as alert-box.
*/                                    

      
      
def var ReturnCode  as INT      NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS bList SelEnum SelRasConn userName bDial ~
bDisconnect PassWord Btn_OK 
&Scoped-Define DISPLAYED-OBJECTS SelEnum SelRasConn userName PassWord INFO 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD RASEnum Dialog-Frame 
FUNCTION RASEnum RETURNS LOGICAL
  ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON bDial 
     LABEL "Dial" 
     SIZE 12 BY .95.

DEFINE BUTTON bDisconnect 
     LABEL "Disconnect" 
     SIZE 17 BY .95.

DEFINE BUTTON bList 
     LABEL "List Connections" 
     SIZE 17 BY .95.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "Exit" 
     SIZE 17 BY .95
     BGCOLOR 8 .

DEFINE VARIABLE INFO AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 52.8 BY 1
     BGCOLOR 3 FGCOLOR 15  NO-UNDO.

DEFINE VARIABLE PassWord AS CHARACTER FORMAT "X(256)":U 
     LABEL "PassWord" 
     VIEW-AS FILL-IN 
     SIZE 27.8 BY 1
     BGCOLOR 15 FGCOLOR 9  NO-UNDO.

DEFINE VARIABLE userName AS CHARACTER FORMAT "X(256)":U 
     LABEL "User name" 
     VIEW-AS FILL-IN 
     SIZE 27.8 BY 1
     BGCOLOR 15 FGCOLOR 9  NO-UNDO.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 0  
     SIZE 52.8 BY 1.24
     BGCOLOR 3 .

DEFINE VARIABLE SelEnum AS CHARACTER 
     VIEW-AS SELECTION-LIST SINGLE SCROLLBAR-VERTICAL 
     SIZE 49.2 BY 12.91 TOOLTIP "All defined connections in your system."
     BGCOLOR 2 FGCOLOR 15  NO-UNDO.

DEFINE VARIABLE SelRasConn AS CHARACTER 
     VIEW-AS SELECTION-LIST SINGLE 
     SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL 
     SIZE 59.8 BY 12.91 TOOLTIP "Active connections."
     BGCOLOR 15 FGCOLOR 9  NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     bList AT ROW 1.19 COL 5.6
     SelEnum AT ROW 2.19 COL 5.8 NO-LABEL
     SelRasConn AT ROW 2.19 COL 55.2 NO-LABEL
     userName AT ROW 15.38 COL 12.4 COLON-ALIGNED
     bDial AT ROW 15.48 COL 44
     bDisconnect AT ROW 15.62 COL 98.2
     PassWord AT ROW 16.48 COL 12.4 COLON-ALIGNED
     Btn_OK AT ROW 16.67 COL 98.2
     INFO AT ROW 16.52 COL 41.8 COLON-ALIGNED NO-LABEL
     "www.4gl.fr" VIEW-AS TEXT
          SIZE 13.4 BY .81 AT ROW 15.57 COL 82.2
          BGCOLOR 3 FGCOLOR 14 FONT 6
     RECT-1 AT ROW 15.33 COL 43.8
     " All connections" VIEW-AS TEXT
          SIZE 20 BY .76 AT ROW 1.14 COL 27.2
          FONT 6
     " Active connections" VIEW-AS TEXT
          SIZE 24.4 BY .76 AT ROW 1.19 COL 55.6
          FONT 6
     SPACE(36.99) SKIP(15.80)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         BGCOLOR 7 FGCOLOR 15 
         TITLE BGCOLOR 3 FGCOLOR 10 "4GL - RAS example from www.4gl.fr"
         DEFAULT-BUTTON Btn_OK.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
                                                                        */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN INFO IN FRAME Dialog-Frame
   NO-ENABLE                                                            */
/* SETTINGS FOR RECTANGLE RECT-1 IN FRAME Dialog-Frame
   NO-ENABLE                                                            */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* 4GL - RAS example from www.4gl.fr */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bDial
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bDial Dialog-Frame
ON CHOOSE OF bDial IN FRAME Dialog-Frame /* Dial */
DO:
Def var RAS as MEMPTR.
Def var lpSize      as INT NO-UNDO.
Def var hRAS        as int NO-UNDO.
Def var OtherReturnCode as int no-undo.

If SelEnum:Screen-VALUE = ""
OR SelEnum:Screen-VALUE = ? then DO :
        Message "You must choose a connection before dialing..."
                view-as alert-box WARNING.
        RETURN.
        END.
        
lpSize = {&lRASDial}.

Def var I as int NO-UNDO.

   
set-size(RAS) = lpSize.
   

/* If you want to set a different Phone number, username or password
   set your attributes in the RASDial structure
   ---------------------------------------------------------------*/
Put-Long(RAS, 1)        =      lpSize.                           /* Entry Size */
Put-String(RAS, 5)      =      SelEnum:Screen-VALUE.             /* Connection Name */

Put-string(RAS, 5 + {&RAS_MaxEntryName}    + 1) = "".                       /* Phone Number */
Put-string(RAS, 5 + {&RAS_MaxEntryName}    + 1
                  + {&RAS_MaxPhoneNumber}  + 1) = "".                       /* CallBack Number */
Put-string(RAS, 5 + {&RAS_MaxEntryName}    + 1
                  + {&RAS_MaxPhoneNumber}  + 1 
                  + {&RAS_MaxCallBackNumber}   + 1) = UserName:Screen-value.        /* user Name */
                                   
Put-string(RAS, 5 + {&RAS_MaxEntryName}    + 1
                  + {&RAS_MaxPhoneNumber}  + 1 
                  + {&RAS_MaxCallBackNumber}   + 1 
                  + {&UNLEN}               + 1) = PassWord:Screen-Value.            /* PassWord */
Put-string(RAS, 5 + {&RAS_MaxEntryName}    + 1
                  + {&RAS_MaxPhoneNumber}  + 1 
                  + {&RAS_MaxCallBackNumber}   + 1 
                  + {&UNLEN}               + 1 
                  + {&PWLEN}               + 1) = "".        /* Domain */
                                                     

Session:set-wait-state("GENERAL").

INFO:SCREEN-VALUE = "Trying to connect to " + SelEnum:Screen-VALUE + "...".

Run RASDialA(
                0,
                0,
                RAS,
                0,
                0,
                output hRAS,
                output ReturnCode
                ).

Session:set-wait-state("").

set-size(RAS) = 0.

If ReturnCode = 0 then
        INFO:SCREEN-VALUE = "You are connected to " + SelEnum:Screen-VALUE.
else do :
        INFO:SCREEN-VALUE = "Error " + string(ReturnCode) + " has occurred.".
        If hRAS <> 0 then
                  Run RasHangUpA( hRAS, output otherReturnCode).  
        Message "Error" ReturnCode "has occured while dialing..."
                skip(1)
                view-as alert-box ERROR.             
        end.


pause 1 no-message.

Apply 'choose' to bList.
                                                 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bDisconnect
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bDisconnect Dialog-Frame
ON CHOOSE OF bDisconnect IN FRAME Dialog-Frame /* Disconnect */
DO:
  def var I                 as int no-undo.
  def var returncode        as int.

  IF SelRasConn:PRIVATE-DATA = "" then do :
        Message "No active connection to hangup."
            view-as alert-box info.
        return.
        end.
          
  I = SelRASConn:LOOKUP(SelRasConn:SCREEN-VALUE).
  
  IF I = 0
  Or I = ? then do :
        Message "You must choose a valid connexion to hangup."
            view-as alert-box info.
        return.
        end.
        
  Def var h as int no-UNDO.
        
  Message "Are you sure that you want to disconnect from"
            skip
           SelRasConn:SCREEN-VALUE "?"
           view-as alert-box question buttons yes-no
           update ok as logical.
           
  if not ok then return.
  
  
  /*    Get the handle of the connection to hangup in the
        private-data
        */
        
  h = int(entry(I, SelRASConn:PRIVATE-DATA)).
     
  Run RasHangUpA( h, output ReturnCode) .
  
  INFO:SCREEN-VALUE = "".
  
  If ReturnCode <> 0 then
            Message "Error" returnCode "from RASHangup."
                    view-as alert-box ERROR.
                    
  Pause 1 no-message.               /* wait 1 second */
  
  Apply "CHOOSE" to bList.          /* and refresh the lists */
 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bList
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bList Dialog-Frame
ON CHOOSE OF bList IN FRAME Dialog-Frame /* List Connections */
DO:

/*  Size of the RAS structures
    ========================*/
             
def var lpsize      as INT      NO-UNDO.
def var RAS         as MEMPTR   NO-UNDO.
def var i           as INT      NO-UNDO.
def var lpcEntries  as INT      NO-UNDO.


def var Nil         as INT      NO-UNDO.

Def var EntryList   as CHAR     NO-UNDO.


    lpSize = ( {&lRasEntryName} ) * 50.

    set-size(RAS)    = lpSize.                      /* reserve for  entries */
    put-long(RAS, 1) = {&lRasEntryName}.            /* the first entry must specify the entry length ! */

    Run RasEnumEntriesA(  input-output Nil, 
                          input-output Nil,
                            RAS,
                          input-output lpSize,
                          input-output lpcEntries
                        ).



    DO I = 1 to lpcEntries :
            EntryList = Entrylist + ',' + get-string(RAS, (I - 1) * ( {&lRasEntryName} ) + 5).                                                
            end.
    
    SelEnum:List-items = substring(EntryList, 2).

    set-size(RAS) = 0.                      /* free the RAS memory */
    lpSize = ( {&lRasConn} ) * 100.        
    set-size(RAS) = lpSize.                 /* reserve space for 100 entries */

    put-long(RAS, 1) = {&lRasConn}.   
                                            
    Run RasEnumConnectionsA(
                            RAS,
                            input-output lpSize,
                            input-output lpcEntries,
                            output ReturnCode
                            ).

    EntryList = "".
    SelRasConn:Private-Data = "".
    
    DO I = 1 to lpcEntries :
            EntryList = Entrylist + ',' + get-string(RAS, (I - 1) * {&lRasConn} + 9)      + "/"
                                        + get-string(RAS, (I - 1) * {&lRasConn} + 9       +
                                                                    {&RAS_MaxEntryName} + 1 ) + "/"
                                        + get-string(RAS, (I - 1) * {&lRasConn} + 9 +
                                                                    {&RAS_MaxEntryName} + 1 + {&RAS_MaxDeviceType} + 1).
                                /* Private-data contains all handles */
            SelRasConn:Private-Data = SelRasConn:Private-Data + "," + string( get-Long(RAS, (I - 1) *  {&lRasConn} + 5 )).                                              
            end.
         
    SelRasConn:List-Items = substring(EntryList, 2).
    SelRasConn:Private-Data = substring( SelRasConn:Private-Data , 2).
                                                  
    set-size(RAS) = 0.    
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY SelEnum SelRasConn userName PassWord INFO 
      WITH FRAME Dialog-Frame.
  ENABLE bList SelEnum SelRasConn userName bDial bDisconnect PassWord Btn_OK 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE RASProcedures Dialog-Frame 
PROCEDURE RASProcedures :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

END PROCEDURE.


procedure RasEnumConnectionsA EXTERNAL "rasapi32.dll".
def input parameter              RR    as MEMPTR  .
def input-output parameter       lsize as long.
def input-output parameter       N     as long. 
def return parameter             ReturnCode as long.
end.

procedure RasEnumEntriesA EXTERNAL "rasapi32.dll".
def input-output  parameter     I       as long.
def input-output  parameter     J       as long.
def input parameter             RR      as MEMPTR  .
def input-output parameter      lsize   as long.
def input-output parameter      N       as long. 
end.

procedure RasHangUpA EXTERNAL "rasapi32.dll".
def input  parameter             h        as long.
def return parameter             ReturnCode as long.
end.

procedure RasDialA EXTERNAL "rasapi32.dll".
def input parameter              I as LONG.
def input parameter              J as LONG.
def input parameter                     RASDialParams       as MEMPTR.
def input parameter              K as LONG.
def input parameter              L as LONG.

def output parameter             hRAS as long.

def return parameter             ReturnCode as long.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION RASEnum Dialog-Frame 
FUNCTION RASEnum RETURNS LOGICAL
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/


END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


